<?php

	############################################################################
	# 	
	#	Meteotemplate
	# 	http://www.meteotemplate.com
	# 	Free website template for weather enthusiasts
	# 	Author: Jachym
	#           Brno, Czech Republic
	# 	First release: 2015
	#
	############################################################################
	#
	#	Standalone ecowitt to realtime.txt ( based on meteotemplates's ecowitt plugin )
	#   Configure gateway to send data to this script, the realtime .txt file will be generated in the same directory
	#
	############################################################################
	#	Version and change log
	#
	#	v1.0  - Jan 11, 2023 (davidefa)
	#         - initial release
	#
	############################################################################


	define('__ROOT__', dirname(dirname(__FILE__)));

    $base = "./";

	$ambientNSensors = 10;
 	$ecowittNSensors = 8;
	$dataFormat = "ecowitt";

	########### GET DATA ############

	# Settings: General
    //ini_set( 'serialize_precision', -1 );       // so json_encode does not 'change roundness' ( for PHP >= 7.1 )
    $LogRealtime = array();

	# Convert HTTP POST variables to json
	if ( !isset($dataFormat) || (isset($dataFormat) && $dataFormat == "ecowitt") )
	    {
	    echo "ecowitt format<br>";
		$LogRealtime['info'][] = "ecowitt format";
		$weather_data = $_POST;
		$weather_data_orig = $_POST;
		}
	# Convert HTTP GET variables to json
	if ( isset($dataFormat) && $dataFormat == "ambient" )
	    {
	    echo "ambient format<br>";
		$LogRealtime['info'][] = "ambient format";
		$weather_data = $_GET;
		$weather_data_orig = $_GET;
		// rename sensor from ambient to ecowitt naming
		if (isset($weather_data['hourlyrainin']))  {@$weather_data['rainratein'] = $weather_data['hourlyrainin'] ;}	// wh51
		for ($i=1; $i<=$ambientNSensors; $i++)
		    {
		    if (isset($weather_data['soiltemp'.$i])) {@$weather_data['tf_ch'.$i] = $weather_data['soiltemp'.$i] ;}       	// wn34
			if (isset($weather_data['soilhum'.$i]))  {@$weather_data['soilmoisture'.$i] = $weather_data['soilhum'.$i] ;}	// wh51
			}
		}

    // log post and get data
    if(isset($_POST))
        {
        foreach($_POST as $urlParameter=>$value)
            {
            if( $urlParameter!="PASSWORD" && $urlParameter!="PASS" && $urlParameter!="PASSKEY" )
                {$LogRealtime['info'][] = "post ".$urlParameter.": ".$value;}
            }
        }
    if(isset($_GET))
        {
        foreach($_GET as $urlParameter=>$value)
            {
            if( $urlParameter!="PASSWORD" && $urlParameter!="PASS" && $urlParameter!="PASSKEY" )
                {$LogRealtime['info'][] = "get ".$urlParameter.": ".$value;}
            }
        }

	# Conversion factors
	$f_mph_kmh = 1.609344;
	$f_mph_kts = 0.868976;
	$f_mph_ms = 0.44704;
	$f_in_hpa = 33.863881;
	$f_in_mm = 25.4;

	# Convert data
    # Temps
    # 2021-02-01 (davidefa)
    /*if (isset($weather_data['windchillf'])) {@$weather_data['windchillc'] = round( ( $weather_data['windchillf'] - 32 ) * 5 / 9, 2 );}
    if (isset($weather_data['tempf']))      {@$weather_data['tempc'] = round( ( $weather_data['tempf'] - 32 ) * 5 / 9, 2 );}
    if (isset($weather_data['tempinf']))    {@$weather_data['tempinc'] = round( ( $weather_data['tempinf'] - 32 ) * 5 / 9, 2 );}
    if (isset($weather_data['dewptf']))     {@$weather_data['dewptc'] = round( ( $weather_data['dewptf'] - 32 ) * 5 / 9, 2 );}	// not used??
	for ($i=1; $i<=max($ambientNSensors,$ecowittNSensors); $i++)
	    {
    	if (isset($weather_data['temp'.$i.'f']))  {@$weather_data['temp'.$i.'c'] = round( ( $weather_data['temp'.$i.'f'] - 32 ) * 5 / 9, 2 );} 	// wh30/wh31
		if (isset($weather_data['tf_ch'.$i]))     {@$weather_data['tc_ch'.$i] = round( ( $weather_data['tf_ch'.$i] - 32 ) * 5 / 9, 2 );}  		// wn34
	 	}

    # Speeds
    if (isset($weather_data['windgustmph']))  {@$weather_data['windgustkmh'] = round( $weather_data['windgustmph'] * $f_mph_kmh, 2 );}
    if (isset($weather_data['windspeedmph'])) {@$weather_data['windspeedkmh'] = round( $weather_data['windspeedmph'] * $f_mph_kmh, 2 );}
	if (isset($weather_data['windspeedmph'])) {@$weather_data['windspeedms'] = round( $weather_data['windspeedmph'] * $f_mph_ms, 2 );}

    # Distances
    if (isset($weather_data['rainin']))        {@$weather_data['rainmm'] = round( $weather_data['rainin'] * $f_in_mm, 2 );}
    if (isset($weather_data['dailyrainin']))   {@$weather_data['dailyrainmm'] = round( $weather_data['dailyrainin'] * $f_in_mm, 2 );}
    if (isset($weather_data['weeklyrainin']))  {@$weather_data['weeklyrainmm'] = round( $weather_data['weeklyrainin'] * $f_in_mm, 2 );}
    if (isset($weather_data['monthlyrainin'])) {@$weather_data['monthlyrainmm'] = round( $weather_data['monthlyrainin'] * $f_in_mm, 2 );}
    if (isset($weather_data['yearlyrainin']))  {@$weather_data['yearlyrainmm'] = round( $weather_data['yearlyrainin'] * $f_in_mm, 2 );}
    if (isset($weather_data['rainratein']))    {@$weather_data['rainratemm'] = round( $weather_data['rainratein'] * $f_in_mm, 2 );}

    # Baros
    if (isset($weather_data['baromabsin'])) {@$weather_data['baromabshpa'] = round( $weather_data['baromabsin'] * $f_in_hpa, 2 );}
    if (isset($weather_data['baromrelin'])) {@$weather_data['baromrelhpa'] = round( $weather_data['baromrelin'] * $f_in_hpa, 2 );}*/

    // Date and time
        $dt = explode(" ",rtrim($weather_data['dateutc'],'Z'));

	// initialize realtimeArray
	$realtimeArray = array();
	for ($i=1; $i<59; $i++)
		{ $realtimeArray[$i]=0.0;
		}
	$realtimeArray[1] = '-'; $realtimeArray[2] = '-'; $realtimeArray[12] = '-'; $realtimeArray[14] = '-'; $realtimeArray[15] = '-'; $realtimeArray[16] = '-'; $realtimeArray[17] = '-';
	$realtimeArray[28] = '-'; $realtimeArray[30] = '-'; $realtimeArray[32] = '-'; $realtimeArray[34] = '-'; $realtimeArray[36] = '-'; $realtimeArray[38] = '-'; $realtimeArray[39] = '-';
	$realtimeArray[52] = '-'; $realtimeArray[54] = '-';
	$realtimeArray[4] = '0'; $realtimeArray[8] = '0'; $realtimeArray[13] = '0'; $realtimeArray[24] = '0'; $realtimeArray[40] = '0'; $realtimeArray[44] = '0'; $realtimeArray[46] = '0'; $realtimeArray[47] = '0'; $realtimeArray[49] = '0'; $realtimeArray[50] = '0'; $realtimeArray[51] = '0'; $realtimeArray[53] = '0'; $realtimeArray[58] = '0';

	// define fields
	$realtimeArray[1] = substr($dt[0],8,2).'/'.substr($dt[0],5,2).'/'.substr($dt[0],2,2);
	$realtimeArray[2] = $dt[1];
	if (isset($weather_data['tempf']))          $realtimeArray[3] = $weather_data['tempf']; $realtimeArray[15] = 'F';
	if (isset($weather_data['humidity']))       $realtimeArray[4] = $weather_data['humidity'];
	if (isset($weather_data['dewptf']))         $realtimeArray[5] = $weather_data['dewptf'];
	if (isset($weather_data['windspeedmph']))   $realtimeArray[6] = $weather_data['windspeedmph']; $realtimeArray[14] = 'mph';
	if (isset($weather_data['windgustmph']))    $realtimeArray[7] = $weather_data['windgustmph'];
	if (isset($weather_data['maxdailygust']))   $realtimeArray[33] = $weather_data['maxdailygust'];
	if (isset($weather_data['winddir']))        $realtimeArray[8] = $weather_data['winddir'];
	if (isset($weather_data['rainratein']))     $realtimeArray[9] = $weather_data['rainratein']; $realtimeArray[17] = 'in';
	if (isset($weather_data['dailyrainin']))    $realtimeArray[10] = $weather_data['dailyrainin'];
	if (isset($weather_data['monthlyrainin']))  $realtimeArray[20] = $weather_data['monthlyrainin'];
	if (isset($weather_data['yearlyrainin']))   $realtimeArray[21] = $weather_data['yearlyrainin'];
	if (isset($weather_data['baromrelin']))     $realtimeArray[11] = $weather_data['baromrelin']; $realtimeArray[16] = 'in';
    if (isset($weather_data['tempinf']))        $realtimeArray[23] = $weather_data['tempinf'];
    if (isset($weather_data['humidityin']))     $realtimeArray[24] = $weather_data['humidityin'];
    if (isset($weather_data['windchillf']))     $realtimeArray[25] = $weather_data['windchillf'];
	if (isset($weather_data['uv']))             $realtimeArray[44] = $weather_data['uv'];
    if (isset($weather_data['solarradiation'])) $realtimeArray[46] = $weather_data['solarradiation'];

	$realtimeString = implode(' ',$realtimeArray);
	file_put_contents("realtime.txt",$realtimeString);
	$LogRealtime['info'][] = "realtime.txt = ".$realtimeString;

	generateLogRealtime($base, $LogRealtime, "realtimeLog.txt");
	echo "Success. Update done\n";


    ############################################################################
    // Functions
    ############################################################################

    function generateLogRealtime($base, $apiLog, $fileName)
        {
        //global $apiLog;
        //global $base;
        // create log and exit update script
        $apiLog['info'][] = "Generating log file ".$fileName;
        $updateLog = "";
        foreach($apiLog['info'] as $info)
            {$updateLog .= $info."\n";}
        $updateLog .= "\nERRORS:\n\r";
        if(isset($apiLog['error']))
            {
            foreach($apiLog['error'] as $error)
                {$updateLog .= $error."\n";}
            }
        file_put_contents($base.$fileName,$updateLog);
        }

?>

