<?php

	// check acces authorization
	session_start();
	if($_SESSION['user']!="admin"){
		echo "Unauthorized access.";
		die();
	}
	
	// load core files
	include("../../config.php");
	include($baseURL."css/design.php");
	include($baseURL."header.php");
	
	// check if settings already exists and if so, load it, otherwise set parameters to default values
	if(file_exists("settings.php")){
		include("settings.php");
	}

	if(!isset($forward_server))              {$forward_server = $baseURL."api.php";}
	if(!isset($forward_server_password))     {$forward_server_password = "meteotemplate admin password";}
	if(!isset($txt_data_log))                {$txt_data_log = false;}
	if(!isset($ws80_temperature_correction)) {$ws80_temperature_correction = false;}	
	if(!isset($use_curl))                    {$use_curl = true;}	

	$parsed = parse_url($pageURL);
	$HTTP_HOST = $parsed['host'];
	$REQUEST_URI = $path . "plugins/ecowitt/";

    if(file_exists('ecowittVersion.txt'))
        {$version = trim(file_get_contents('ecowittVersion.txt'));}
	else
		{$version = "";}
?>

<?php
   // user has clicked a delete hyperlink
   if($_GET['action'] && $_GET['action'] == 'delete') {
       unlink($_GET['filename']);
       header("Location:setup.php");
       exit();
   }
?>

<!DOCTYPE html>
<html>
	<head>
		<title><?php echo $pageName?></title>
		<?php metaHeader()?>
		<style type="text/css">
		<!--
		input.largerCheckbox
		{
			width: 20px;
			height: 20px;
		}
		//-->	
		.tg  {border-collapse:collapse;border-spacing:0;align:center}
		.tg td{font-family:Arial, sans-serif;font-size:14px;padding:10px 5px;border-style:solid;border-width:1px;overflow:hidden;word-break:normal;border-color:black;}
		.tg th{font-family:Arial, sans-serif;font-size:14px;font-weight:normal;padding:10px 5px;border-style:solid;border-width:1px;overflow:hidden;word-break:normal;border-color:black;}
		.tg .tg-0lax{text-align:left;vertical-align:top}
		.tg .tg-1lax{text-align:center;vertical-align:top}
		</style>
	</head>
	<body>
		<div id="main_top">
			<?php bodyHeader()?>
			<?php include($baseURL."menu.php");?>
		</div>
		<div id="main" style="text-align:center">
			<h1>Ecowitt - Setup <?php echo "v".$version?></h1>
			<form method="POST" action="saveSettings.php" target="_blank">
				<table style="width:98%;margin:0 auto">
					<tr><td><b>Basic Setting</b></td></tr>
					<tr>
						<td style="text-align:left;width:500px">
							Input data format
						</td>
						<td style="text-align:left">
							<select name="dataFormat" class="button2">
								<option value="ecowitt" <?php if($dataFormat=="ecowitt"){echo "selected";}?>>Ecowitt</option>
								<option value="ambient" <?php if($dataFormat=="ambient"){echo "selected";}?>>Ambient</option>
							</select>
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Enable authentication
						</td>
						<td style="text-align:left">
							<select name="checkPassword" class="button2">
								<option value="password" <?php if($checkPassword=="password"){echo "selected";}?>>Password</option>
								<option value="passkey"  <?php if($checkPassword=="passkey"){echo "selected";}?>>PASSKEY</option>
								<option value="false"    <?php if(!$checkPassword=="false"){echo "selected";}?>>No</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							PASSKEY  ( if enabled )
						</td>
						<td style="text-align:left">
							<input name="authPasskey" size="40" class="button2" value="<?php echo $authPasskey?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Url of this site api.php script  ( should be: <b><?php echo "$pageURL"."$path"?>api.php</b> )
						</td>
						<td style="text-align:left">
							<input name="forward_server" size="80" class="button2" value="<?php echo $forward_server?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Call api.php using 'curl' ( yes = use curl  no = use require )
						</td>
						<td style="text-align:left">
							<select name="use_curl" class="button2">
								<option value="true" <?php if($use_curl){echo "selected";}?>>Yes</option>
								<option value="false" <?php if(!$use_curl){echo "selected";}?>>No</option>
							</select>						
						</td>						
					</tr>	
					<tr>
						<td style="text-align:left;width:500px">
							Record data in CSV format
						</td>
						<td style="text-align:left">
							<select name="txt_data_log" class="button2">
								<option value="true" <?php if($txt_data_log){echo "selected";}?>>Yes</option>
								<option value="false" <?php if(!$txt_data_log){echo "selected";}?>>No</option>
							</select>
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Record data in JSON format
						</td>
						<td style="text-align:left">
							<select name="json_data_log" class="button2">
								<option value="true" <?php if($json_data_log){echo "selected";}?>>Yes</option>
								<option value="false" <?php if(!$json_data_log){echo "selected";}?>>No</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Generate realtime.txt ( CumulusMX format, url: <b><?php echo "$pageURL"."$path"?>plugins/ecowitt/realtime.txt</b> )
						</td>
						<td style="text-align:left">
							<select name="realtime_data_log" class="button2">
								<option value="true" <?php if($realtime_data_log){echo "selected";}?>>Yes</option>
								<option value="false" <?php if(!$realtime_data_log){echo "selected";}?>>No</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							UTC/Local Time ( in realtime.txt )
						</td>
						<td style="text-align:left">
							<select name="realtime_utc_time" class="button2">
								<option value="true" <?php if($realtime_utc_time){echo "selected";}?>>UTC</option>
								<option value="false" <?php if(!$realtime_utc_time){echo "selected";}?>>Local</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Metric/Imperial Units ( in realtime.txt )
						</td>
						<td style="text-align:left">
							<select name="realtime_metric_unit" class="button2">
								<option value="true" <?php if($realtime_metric_unit){echo "selected";}?>>Metric</option>
								<option value="false" <?php if(!$realtime_metric_unit){echo "selected";}?>>Imperial</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Calculate daily min/max ( in realtime.txt )
						</td>
						<td style="text-align:left">
							<select name="realtime_calculate_minmax" class="button2">
								<option value="true" <?php if($realtime_calculate_minmax){echo "selected";}?>>Yes</option>
								<option value="false" <?php if(!$realtime_calculate_minmax){echo "selected";}?>>No</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Enable <a href="http://www.kwos.it/joomla/weather-monitoring/articoli/139-ecowitt-ws80-correzione-della-temperatura-rilevata" target="_blank">Temperature correction</a> for WS80.
							Past values of Solar Radiation, Wind Speed and Temp. are retieved from database.
						</td>
						<td style="text-align:left">
							<select name="ws80_temperature_correction" class="button2">
								<option value="true" <?php if($ws80_temperature_correction){echo "selected";}?>>Yes</option>
								<option value="false" <?php if(!$ws80_temperature_correction){echo "selected";}?>>No</option>
							</select>						
						</td>						
					</tr>	
					<tr>
						<td style="text-align:left;width:500px">
							Calculate Evapotranspiration ET0
						</td>
						<td style="text-align:left">
							<select name="et0_calculate" class="button2">
								<option value="true" <?php if($et0_calculate){echo "selected";}?>>Yes</option>
								<option value="false" <?php if(!$et0_calculate){echo "selected";}?>>No</option>
							</select>						
						</td>						
					</tr>	
					<tr>
						<td style="text-align:left;width:300px">
							Default elevation ( for ET0 calculation )
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $defaultElevation?>" name="defaultElevation" size="3"> Local elevation in meters<br>
						</td>
					</tr>
					<tr>
						<td style="text-align:left">
							Default wind measurement height ( for ET0 calculation )
						</td>
						<td style="text-align:left">
							<input class="button2" value="<?php echo $defaultWindHeight?>" name="defaultWindHeight" size="3"> Height of anemometer ( above ground ) in meters<br>
						</td>
					</tr>
					<tr><td><br><br><b>Advanced Setting</b></td></tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward data format 1 ( select Off if not used )
						</td>
						<td style="text-align:left">
							<select name="forward_data_1" class="button2">
								<option value="off" <?php if($forward_data_1=="off"){echo "selected";}?>>Off</option>
								<option value="awekas" <?php if($forward_data_1=="awekas"){echo "selected";}?>>Awekas</option>
								<option value="ecowitt" <?php if($forward_data_1=="ecowitt"){echo "selected";}?>>Ecowitt</option>
								<option value="wu" <?php if($forward_data_1=="wu"){echo "selected";}?>>WU</option>
								<option value="wuext" <?php if($forward_data_1=="wuext"){echo "selected";}?>>WUEXT</option>
								<option value="weatherwizz" <?php if($forward_data_1=="weatherwizz"){echo "selected";}?>>Weatherwizz</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward to server 1 url ( ex: http://www.example.com )
						</td>
						<td style="text-align:left">
							<input name="forward_server_1" size="80" class="button2" value="<?php echo $forward_server_1?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 1 port ( ex: 8080 ). Leave empty if not used.
						</td>
						<td style="text-align:left">
							<input name="forward_port_1" size="10" class="button2" value="<?php echo $forward_port_1?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 1 id/username ( Leave empty if not used )
						</td>
						<td style="text-align:left">
							<input name="forward_username_1" size="40" class="button2" value="<?php echo $forward_username_1?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 1 password ( Leave empty if not used )
						</td>
						<td style="text-align:left">
							<input name="forward_password_1" size="40" class="button2" value="<?php echo $forward_password_1?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward data format 2 ( select Off if not used )
						</td>
						<td style="text-align:left">
							<select name="forward_data_2" class="button2">
								<option value="off" <?php if($forward_data_2=="off"){echo "selected";}?>>Off</option>
								<option value="awekas" <?php if($forward_data_2=="awekas"){echo "selected";}?>>Awekas</option>
								<option value="ecowitt" <?php if($forward_data_2=="ecowitt"){echo "selected";}?>>Ecowitt</option>
								<option value="wu" <?php if($forward_data_2=="wu"){echo "selected";}?>>WU</option>
								<option value="wuext" <?php if($forward_data_2=="wuext"){echo "selected";}?>>WUEXT</option>
								<option value="weatherwizz" <?php if($forward_data_2=="weatherwizz"){echo "selected";}?>>Weatherwizz</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward to server 2 url ( ex: http://www.example.com )
						</td>
						<td style="text-align:left">
							<input name="forward_server_2" size="80" class="button2" value="<?php echo $forward_server_2?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 2 port ( ex: 8080 ). Leave empty if not used.
						</td>
						<td style="text-align:left">
							<input name="forward_port_2" size="10" class="button2" value="<?php echo $forward_port_2?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 2 id/username ( Leave empty if not used )
						</td>
						<td style="text-align:left">
							<input name="forward_username_2" size="40" class="button2" value="<?php echo $forward_username_2?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 2 password ( Leave empty if not used )
						</td>
						<td style="text-align:left">
							<input name="forward_password_2" size="40" class="button2" value="<?php echo $forward_password_2?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward data format 3 ( select Off if not used )
						</td>
						<td style="text-align:left">
							<select name="forward_data_3" class="button2">
								<option value="off" <?php if($forward_data_3=="off"){echo "selected";}?>>Off</option>
								<option value="awekas" <?php if($forward_data_3=="awekas"){echo "selected";}?>>Awekas</option>
								<option value="ecowitt" <?php if($forward_data_3=="ecowitt"){echo "selected";}?>>Ecowitt</option>
								<option value="wu" <?php if($forward_data_3=="wu"){echo "selected";}?>>WU</option>
								<option value="wuext" <?php if($forward_data_3=="wuext"){echo "selected";}?>>WUEXT</option>
								<option value="weatherwizz" <?php if($forward_data_3=="weatherwizz"){echo "selected";}?>>Weatherwizz</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward to server 3 url ( ex: http://www.example.com )
						</td>
						<td style="text-align:left">
							<input name="forward_server_3" size="80" class="button2" value="<?php echo $forward_server_3?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 3 port ( ex: 8080 ). Leave empty if not used.
						</td>
						<td style="text-align:left">
							<input name="forward_port_3" size="10" class="button2" value="<?php echo $forward_port_3?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 3 id/username ( Leave empty if not used )
						</td>
						<td style="text-align:left">
							<input name="forward_username_3" size="40" class="button2" value="<?php echo $forward_username_3?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 3 password ( Leave empty if not used )
						</td>
						<td style="text-align:left">
							<input name="forward_password_3" size="40" class="button2" value="<?php echo $forward_password_3?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward data format 4 ( select Off if not used )
						</td>
						<td style="text-align:left">
							<select name="forward_data_4" class="button2">
								<option value="off" <?php if($forward_data_4=="off"){echo "selected";}?>>Off</option>
								<option value="awekas" <?php if($forward_data_4=="awekas"){echo "selected";}?>>Awekas</option>
								<option value="ecowitt" <?php if($forward_data_4=="ecowitt"){echo "selected";}?>>Ecowitt</option>
								<option value="wu" <?php if($forward_data_4=="wu"){echo "selected";}?>>WU</option>
								<option value="wuext" <?php if($forward_data_4=="wuext"){echo "selected";}?>>WUEXT</option>
								<option value="weatherwizz" <?php if($forward_data_4=="weatherwizz"){echo "selected";}?>>Weatherwizz</option>
							</select>						
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward to server 4 url ( ex: http://www.example.com )
						</td>
						<td style="text-align:left">
							<input name="forward_server_4" size="80" class="button2" value="<?php echo $forward_server_4?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 4 port ( ex: 8080 ). Leave empty if not used.
						</td>
						<td style="text-align:left">
							<input name="forward_port_4" size="10" class="button2" value="<?php echo $forward_port_4?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 4 id/username ( Leave empty if not used )
						</td>
						<td style="text-align:left">
							<input name="forward_username_4" size="40" class="button2" value="<?php echo $forward_username_4?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Forward server 4 password ( Leave empty if not used )
						</td>
						<td style="text-align:left">
							<input name="forward_password_4" size="40" class="button2" value="<?php echo $forward_password_4?>">
						</td>
					</tr>
					<tr><td><br><br><b>Renaming / Remapping</b></td></tr>
					<tr>
						<td style="text-align:left;width:500px">
							Rename sensors - meteotemplate format ( format: meteotemplate_field_new=meteotemplate_field_old;... ex: PP2=PP1;T=T1 ) the 'old_field' is deleted
						</td>
						<td style="text-align:left">
							<input name="rename_sensor" size="80" class="button2" value="<?php echo $rename_sensor?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Math with sensors - meteotemplate format ( format: meteotemplate_field=#meteotemplate_field#+#meteotemplate_field#;... ex: T5=#T1#-#T4# )
						</td>
						<td style="text-align:left">
							<input name="math_meteotemplate" size="80" class="button2" value="<?php echo $math_meteotemplate?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Remap sensors - meteotemplate format ( format: meteotemplate_field=ecowitt_field;... ex: PP1=pm25_co2;PP2=pm10_co2 )
						</td>
						<td style="text-align:left">
							<input name="remap_ecowitt" size="80" class="button2" value="<?php echo $remap_ecowitt?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Remap sensors - wu format ( format: wu_field=ecowitt_field;... ex: rainin=hourlyrainin )
						</td>
						<td style="text-align:left">
							<input name="remap_wu" size="80" class="button2" value="<?php echo $remap_wu?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Remap sensors - awekas format ( format: awekas_field=ecowitt_field;... ex: AqPM2.5=pm25_ch2 )
						</td>
						<td style="text-align:left">
							<input name="remap_awekas" size="80" class="button2" value="<?php echo $remap_awekas?>">
						</td>
					</tr>
					<tr>
						<td style="text-align:left;width:500px">
							Remap sensors - weatherwizz format ( format: weatherwizz_field=ecowitt_field;... ex: AqPM2.5=pm25_ch2 )
						</td>
						<td style="text-align:left">
							<input name="remap_weatherwizz" size="80" class="button2" value="<?php echo $remap_weatherwizz?>">
						</td>
					</tr>
				    <tr><td colspan=2><br><br><div style="width:50%;text-align:center;margin:0 auto"><input type="submit" value="Save" class="button2"></div></td></tr>
					<tr><td><br><br><b>Gateway / Console / WsView Setting</b></td></tr>
					<tr>
						<td style="text-align:left;width:500px" colspan="2">
							Set your Ecowitt gateway/console (GW1000/GW1100/WH2650/WN1900...) to send data to:<br>
							Server IP/Hostname: <b><?php echo $HTTP_HOST?></b><br>
							Path: <b><?php echo $REQUEST_URI . 'report/' ?></b><br>
							Path: <b><?php echo $REQUEST_URI . 'report/index.php?PASS=xxx ( use this format if Enable authentication = password, xxx=update password )' ?></b>
							<br><br>
						</td>
					</tr>
					<tr><td><br><br><b>JSON / CSV Data</b></td></tr>
					<tr>
						<td style="text-align:left;width:500px" colspan="2">
							<?php
							$dir = "./";
							$allFiles = scandir($dir);
							$files = preg_grep("/^(\.|\.\.|report|(.*)\.php|(.*)\.txt|(.*)\.csv)$/",$allFiles, PREG_GREP_INVERT);
							foreach($files as $file){
								echo "JSON file is: <b><a href='http://" . $HTTP_HOST . $REQUEST_URI . $file . "' target=_blank>http://" . $HTTP_HOST . $REQUEST_URI . $file ."</a></b><br>";
							}	
							?>
							<br><br>
						</td>
					</tr>					
					<tr>
						<td style="text-align:left;width:500px" colspan="2">
							CSV data will be saved to: <b><?php echo $baseURL?>plugins/ecowitt/</b>
							<br><br>
						</td>
					</tr>						
				</table>
			</form>
			<br><br>
			<center>
			<table class="tg">
			<tr>
				<td class='tg-1lax'>Log files (click on to download)</td>
				<td class='tg-1lax'>Command</td>
			</tr>	
			<?php
				$dir = "./";

				$allFiles = scandir($dir);
				$files = preg_grep("/^(\.|\.\.|report|(.*)\.php|(.*)\.txt|(.*)\.json)$/",$allFiles, PREG_GREP_INVERT);
				foreach($files as $file){
					echo "<tr>";
					echo "<td class='tg-0lax'><a href='download.php?file=".$file."'>".$file."</a></td>";
					echo "<td class='tg-0lax'><a href='setup.php?action=delete&filename=".$file."'>delete</a></td>";
					echo "</tr>";
				}

			?>
			</table>
			</center>
		</div>
		<?php include($baseURL."footer.php");?>
	</body>
</html>